﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim parser As SaxParser
	Dim XMLDocParams As Map 
	Dim ClassList As List 
	
	Dim mModule As Object 
	Dim mEventName As String 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pModule As Object, pEventname As String)
	mModule= pModule
	mEventName = pEventname
	parser.Initialize
	XMLDocParams.Initialize 
	ClassList.Initialize 
End Sub

Public Sub Parse(FilePath As String)
	Dim io As InputStream = File.OpenInput(FilePath, "")
	parser.Parse(io, "parser")
	XMLDocParams.Put("libname", File.GetName(FilePath))
	XMLDocParams.Put("classes", ClassList)
End Sub

Private Sub parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
	If Name.ToLowerCase = "version" OR _
	   Name.ToLowerCase = "author" OR _
	   Name.ToLowerCase = "dependson"   Then
		XMLDocParams.Put(Name.ToLowerCase, Text.ToString)
	End If
	If Name.ToLowerCase = "shortname" Then
		ClassList.Add(Text.ToString)
	End If
	'End of parsing
	If Name.ToLowerCase = "root" Then
		CallSubDelayed2(mModule, mEventName & "_ParseDone", XMLDocParams)
	End If
End Sub

