﻿Type=Class
Version=2.8
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private txtfile, btnbrowse, btnupload As JQueryElement
	
	Private form1 As JQueryElement
	Private Result As JQueryElement
	
	Private LibMap As Map 
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	form1.RunMethod("ajaxForm", Null)
	ws.Session.SetAttribute("file_upload_sender", Me)
End Sub

Private Sub WebSocket_Disconnected
	'remote the class instance from the session
	ws.Session.RemoveAttribute("file_upload_sender")
End Sub

Public Sub FileUploaded(parts As Map)
	Dim filePart As Part   = parts.Get("txtfile")
	Dim catPart As Part    = parts.Get("txttags")
	Dim descPart As Part   = parts.Get("txtdesc")
	Dim forumPart As Part  = parts.Get("txtforum")
	Dim directPart As Part = parts.Get("txtdirect")
	Log(parts)
	Result.SetText("File uploaded successfully: " & filePart.SubmittedFilename & _
		" size = " & NumberFormat(File.Size("", filePart.TempFile) / 1000, 0, 0) & "kb")
	Log("Tempfile:" & filePart.TempFile)
	File.Copy(filePart.TempFile,"",File.DirApp,filePart.SubmittedFilename)
	
	LibMap.Initialize 
	LibMap.Put("tags", catPart.GetValue("UTF8"))
	LibMap.Put("description", descPart.GetValue("UTF8"))
	LibMap.Put("forumlink", forumPart.GetValue("UTF8"))
	LibMap.Put("directlink", directPart.GetValue("UTF8"))
	Log(LibMap)
	
	Dim xparse As clsXMLDocParser 
	xparse.Initialize(Me, "xparse")
	xparse.Parse(File.Combine(File.DirApp, filePart.SubmittedFilename))
	Result.SetCSS("color", "black")
	File.Delete("", filePart.TempFile)
	ws.Flush 'this is a server event so we need to explicitly call Flush
End Sub

Public Sub FileError(Message As String)
	Result.SetText("Error uploading file: " & Message)
	Result.SetCSS("color", "red")
	ws.Flush
End Sub

Sub xparse_ParseDone(XMLDocParams As Map)
	Log(XMLDocParams)
	For Each key As String In XMLDocParams.Keys 
		LibMap.Put(key, XMLDocParams.Get(key))
	Next
	Log(LibMap)
	Main.DBManager.InsertLibrary(LibMap)
End Sub